import { lerp } from './util.js';

let x = 0;
let y = 0;
let y_ = 0;
let x_ = 0;
let zoom = 0;

let xoffset = 0;

let shake = 0;

export function AddX() {
	xoffset+=x;
}
export function Shake() {
	shake = 3;
}

let bg, bg_grad;

export function cameraInit() {
	x = 0;
	y = 540/2;
	zoom = 1;
	
	runtime.globalVars.ScriptLayoutX = x;
	runtime.globalVars.ScriptLayoutY = y;
	runtime.globalVars.ScriptLayoutScale = zoom;
	
	bg = runtime.objects.MainBackground.createInstance("Background", 0, 0);
	bg.width = 960;
	bg.height = 540;
	bg.imageScaleX = 0.15;
	bg.imageScaleY = 0.15;
	
	bg_grad = runtime.objects.BackgroundGradiant.createInstance("Background", 0, 0);
	bg_grad.width = 960;
	bg_grad.height = 512;
}

const cameraLerpX = 5;
const cameraLerpY = 2;

let prevPlayerState = 'moving';

export function cameraTick() {
	const player = runtime.objects.Player.getFirstInstance();
	
	const target = player.x + 250;
	if (player.state === 'paused' && prevPlayerState !== 'moving') {
		x = lerp(x, target, cameraLerpX * dt);
	} else {
		x = target;
	}
	prevPlayerState = player.state;
	
	if (player.y > y + 200) {
		y = player.y - 200;
	}
	if (player.y < y - 200) {
		y = player.y + 200;
	}
	if (player.y > 300) {
		y = 540/2;
	}
	
	zoom = 1;
	
	// used to be global vars but for screen shake i need one more layer of stuff
	x_ = x;
	y_ = lerp(runtime.globalVars.ScriptLayoutY, y, cameraLerpY * dt);
	runtime.globalVars.ScriptLayoutScale = lerp(runtime.globalVars.ScriptLayoutScale, zoom, cameraLerpY * dt);
	
	runtime.globalVars.ScriptLayoutX = x_ + (Math.random()*2-1) * shake;
	runtime.globalVars.ScriptLayoutY = y_ + (Math.random()*2-1) * shake;
	shake = lerp(shake, 0, dt * 10);
	
	bg.imageOffsetX = (runtime.globalVars.ScriptLayoutX + xoffset) * -0.8;
	bg.imageOffsetY = runtime.globalVars.ScriptLayoutY * -0.95;
	bg.imageScaleX = 0.15 * runtime.globalVars.ScriptLayoutScale;
	bg.imageScaleY = 0.15 * runtime.globalVars.ScriptLayoutScale;
	
	bg_grad.y = Math.min(y * 0.3 - 300, 0);
}
