import { getTargetAngle, step, applyVel, applyAccel, lerp, intersects, offsetRect, isPressingJump, isPressingUnpause, isPressingRotateLeft, isPressingRotateRight, key } from './util.js'

const mod = 600; // outwards multiplier
const mod2 = -40; // scale down accel

export function tick(dp) {
	dp.life += dt;
	
	if (dp.life < 0.25) {
		dp.scale = lerp(dp.scale, 1, dt * 30);
	}
	
	if (dp.life > 0.4) {
		dp.scale = applyAccel(dp.scale, dp.scalev, mod2)
		dp.scalev = dp.scalev + dt * mod2;
	}
	
	dp.x += mod * dp.vx * dp.vel * dt;
	dp.y += mod * dp.vy * dp.vel * dt;
	
	dp.vel = lerp(dp.vel, 0, dt * 12);
	
	dp.width = dp.scale * 36;
	dp.height = dp.scale * 36;
	
	if (dp.scale < 0) {
		dp.destroy()
	}
}