/*
got game main script.
created entirely by dave caruso; may 2021

i had a bit of schoolwork and other stuff to do, which has lead this code into a HUGE mess.
let me try and explain it.


everything is in javascript, as i can work in that MUCH FASTER than c3 events. now heres a breakdown

- camera.js        - controlling the three camera variables, and also the two background objects (gradient and tiledbg)
                     look at the main event sheet for how i actually move the camera. but the javascript
				 	code calculates WHERE

- constants.js     - player physics constants. basic math calculations; used desmos to help. etc

- main.js          - [this file] the entry script. it calls the other scripts, and also generates [some] of the objects.
                     this also handles the global R reset button.

- player.js        - MOST OF THE GAME CODE. it handles the player logic, and all the pausing logic, and also the save file.
                     at the time of writing i have not added any of the text overlays or even the audio transitioning, i bet
                     it handles that too.

- deathparticle.js - Death particles. just the movement and animation and deletion of them.

- util.js          - random functions i used througout the project



ALSO, this game goes fully on delta-timing, which i store in the `dt` global. the runtime is also in the `runtime` global.


*/

import * as c from './constants.js'
import * as PlayerLogic from './player.js';
import * as PlayerVisualLogic from './player-visual.js';
import * as CameraLogic from './camera.js';
import * as DeathParticles from './deathparticle.js';
import { initTouchTracking, key } from './util.js';

runOnStartup(async r => {
	globalThis.runtime = r;
	runtime.addEventListener("tick", () => tick());
	
	initTouchTracking();
});

function initLayout() {
	runtime.objects.Player.getAllInstances().map(x => x.destroy())
	runtime.objects.MainBackground.getAllInstances().map(x => x.destroy())
	runtime.objects.BackgroundGradiant.getAllInstances().map(x => x.destroy())
	runtime.objects.PauseVisual.getAllInstances().map(x => x.destroy())
	runtime.objects.DeathParticle.getAllInstances().map(x => x.destroy())
		
	CameraLogic.cameraInit();

	const markerPlayer = runtime.objects.MarkerPlayer.getFirstInstance();
	
	const player = runtime.objects.Player.createInstance("Player", markerPlayer.x + 32, markerPlayer.y + 32)
	PlayerLogic.playerInit(player);
	
	runtime.objects.Pause.getAllInstances().map(x => {
		const v = runtime.objects.PauseVisual.createInstance("LevelContents", x.x, x.y - 256 + 64);
		v.width = 64;
		v.height = 256;
	})
}

function tick() {
	if (runtime.layout.name !== "Level")return;
	
	if (runtime.objects.Player.getAllInstances().length === 0){
		initLayout();
	};
	
	globalThis.dt = runtime.dt;
	
	PlayerLogic.playerTick();
	CameraLogic.cameraTick();
	
	runtime.objects.DeathParticle.getAllInstances().map(x => DeathParticles.tick(x));
}
