globalThis.TAU = Math.PI * 2;
globalThis.TAU_2 = TAU / 2;
globalThis.TAU_4 = TAU / 4;
globalThis.TAU_8 = TAU / 8;

export function getTargetAngle(angle) {
	return Math.round((angle % TAU) / TAU_4) * TAU_4;
}

export function lerp(current, target, perc) {
	return current + perc * (target - current);
}

export function step(current, target, amount) {
	return current > target
			? Math.max(target, current - amount * dt)
			: Math.min(target, current + amount * dt);
}

export function applyVel(x, v) { return x + v * dt; }
export function applyAccel(x, v, a) { return x + (v * dt) + (0.5 * a * (dt * dt)); }

export function offsetRect({ x, y, width, height }, ox, oy) {
	return { x: x + ox, y: y + oy, width: width, height: height };
};

export function key(k) {
  return runtime.keyboard.isKeyDown(k);
}

export function intersects(r1, r2) {
	return (r1.x + r1.width) >= (r2.x)
		&& (r1.x) <= (r2.x + r2.width)
		&& (r1.y) <= (r2.y + r2.height - 0.002)
		&& (r1.y + r1.height - 0.002) >= (r2.y)
}

let pointerDown = false;

export function isPressingJump() {
	return (
  		runtime.keyboard.isKeyDown("ArrowUp")
	);
}

export function isPressingRotateLeft() {
	return (
  		runtime.keyboard.isKeyDown("ArrowLeft")
	);
}
export function isPressingRotateRight() {
	return (
  		runtime.keyboard.isKeyDown("ArrowRight")
	);
}
export function isPressingUnpause() {
	return (
  		runtime.keyboard.isKeyDown("ArrowDown")
		|| runtime.keyboard.isKeyDown("ArrowUp")
	);
}


export function initTouchTracking() {
	runtime.addEventListener("pointerdown", () => pointerDown = true);
	runtime.addEventListener("pointerup", () => pointerDown = false);
	runtime.addEventListener("pointercancel", () => pointerDown = false);
}